diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/functions.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/functions.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/functions.php	2013-09-10 23:50:02.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/functions.php	2013-10-17 00:17:08.000000000 -0500
***************
*** 282,287 ****
--- 282,288 ----
  			} elseif ( false === strpos( $data, '"' ) ) {
  				return false;
  			}
+ 			// or else fall through
  		case 'a' :
  		case 'O' :
  			return (bool) preg_match( "/^{$token}:[0-9]+:/s", $data );
***************
*** 412,417 ****
--- 413,438 ----
  }
  
  /**
+  * Use RegEx to extract URLs from arbitrary content
+  *
+  * @since 3.7.0
+  *
+  * @param string $content
+  * @return array URLs found in passed string
+  */
+ function wp_extract_urls( $content ) {
+ 	preg_match_all(
+ 		"#((?:[\w-]+://?|[\w\d]+[.])[^\s()<>]+[.](?:\([\w\d]+\)|(?:[^`!()\[\]{};:'\".,<>?«»“”‘’\s]|(?:[:]\d+)?/?)+))#",
+ 		$content,
+ 		$post_links
+ 	);
+ 
+ 	$post_links = array_unique( array_map( 'html_entity_decode', $post_links[0] ) );
+ 
+ 	return array_values( $post_links );
+ }
+ 
+ /**
   * Check content for video and audio links to add as enclosures.
   *
   * Will not add enclosures that have already been added and will
***************
*** 436,457 ****
  
  	$pung = get_enclosed( $post_ID );
  
! 	$ltrs = '\w';
! 	$gunk = '/#~:.?+=&%@!\-';
! 	$punc = '.:?\-';
! 	$any = $ltrs . $gunk . $punc;
! 
! 	preg_match_all( "{\b http : [$any] +? (?= [$punc] * [^$any] | $)}x", $content, $post_links_temp );
  
  	foreach ( $pung as $link_test ) {
! 		if ( !in_array( $link_test, $post_links_temp[0] ) ) { // link no longer in post
  			$mids = $wpdb->get_col( $wpdb->prepare("SELECT meta_id FROM $wpdb->postmeta WHERE post_id = %d AND meta_key = 'enclosure' AND meta_value LIKE (%s)", $post_ID, like_escape( $link_test ) . '%') );
  			foreach ( $mids as $mid )
  				delete_metadata_by_mid( 'post', $mid );
  		}
  	}
  
! 	foreach ( (array) $post_links_temp[0] as $link_test ) {
  		if ( !in_array( $link_test, $pung ) ) { // If we haven't pung it already
  			$test = @parse_url( $link_test );
  			if ( false === $test )
--- 457,473 ----
  
  	$pung = get_enclosed( $post_ID );
  
! 	$post_links_temp = wp_extract_urls( $content );
  
  	foreach ( $pung as $link_test ) {
! 		if ( ! in_array( $link_test, $post_links_temp ) ) { // link no longer in post
  			$mids = $wpdb->get_col( $wpdb->prepare("SELECT meta_id FROM $wpdb->postmeta WHERE post_id = %d AND meta_key = 'enclosure' AND meta_value LIKE (%s)", $post_ID, like_escape( $link_test ) . '%') );
  			foreach ( $mids as $mid )
  				delete_metadata_by_mid( 'post', $mid );
  		}
  	}
  
! 	foreach ( (array) $post_links_temp as $link_test ) {
  		if ( !in_array( $link_test, $pung ) ) { // If we haven't pung it already
  			$test = @parse_url( $link_test );
  			if ( false === $test )
***************
*** 685,698 ****
  	}
  
  	if ( strpos( $uri, '?' ) !== false ) {
! 		$parts = explode( '?', $uri, 2 );
! 		if ( 1 == count( $parts ) ) {
! 			$base = '?';
! 			$query = $parts[0];
! 		} else {
! 			$base = $parts[0] . '?';
! 			$query = $parts[1];
! 		}
  	} elseif ( $protocol || strpos( $uri, '=' ) === false ) {
  		$base = $uri . '?';
  		$query = '';
--- 701,708 ----
  	}
  
  	if ( strpos( $uri, '?' ) !== false ) {
! 		list( $base, $query ) = explode( '?', $uri, 2 );
! 		$base .= '?';
  	} elseif ( $protocol || strpos( $uri, '=' ) === false ) {
  		$base = $uri . '?';
  		$query = '';
***************
*** 1024,1033 ****
  		$feed = get_default_feed();
  
  	$hook = 'do_feed_' . $feed;
! 	if ( !has_action($hook) ) {
! 		$message = sprintf( __( 'ERROR: %s is not a valid feed template.' ), esc_html($feed));
! 		wp_die( $message, '', array( 'response' => 404 ) );
! 	}
  
  	do_action( $hook, $wp_query->is_comment_feed );
  }
--- 1034,1041 ----
  		$feed = get_default_feed();
  
  	$hook = 'do_feed_' . $feed;
! 	if ( ! has_action( $hook ) )
! 		wp_die( __( 'ERROR: This is not a valid feed template.' ), '', array( 'response' => 404 ) );
  
  	do_action( $hook, $wp_query->is_comment_feed );
  }
***************
*** 1295,1300 ****
--- 1303,1310 ----
   * @return string|bool False on failure. Referer URL on success.
   */
  function wp_get_referer() {
+ 	if ( ! function_exists( 'wp_validate_redirect' ) )
+ 		return false;
  	$ref = false;
  	if ( ! empty( $_REQUEST['_wp_http_referer'] ) )
  		$ref = wp_unslash( $_REQUEST['_wp_http_referer'] );
***************
*** 1316,1322 ****
   * @return string|bool False if no original referer or original referer if set.
   */
  function wp_get_original_referer() {
! 	if ( !empty( $_REQUEST['_wp_original_http_referer'] ) )
  		return wp_validate_redirect( wp_unslash( $_REQUEST['_wp_original_http_referer'] ), false );
  	return false;
  }
--- 1326,1332 ----
   * @return string|bool False if no original referer or original referer if set.
   */
  function wp_get_original_referer() {
! 	if ( ! empty( $_REQUEST['_wp_original_http_referer'] ) && function_exists( 'wp_validate_redirect' ) )
  		return wp_validate_redirect( wp_unslash( $_REQUEST['_wp_original_http_referer'] ), false );
  	return false;
  }
***************
*** 1355,1373 ****
  	if ( file_exists( $target ) )
  		return @is_dir( $target );
  
! 	// Attempting to create the directory may clutter up our display.
! 	if ( @mkdir( $target ) ) {
! 		$stat = @stat( dirname( $target ) );
! 		$dir_perms = $stat['mode'] & 0007777;  // Get the permission bits.
! 		@chmod( $target, $dir_perms );
! 		return true;
! 	} elseif ( is_dir( dirname( $target ) ) ) {
! 			return false;
  	}
  
! 	// If the above failed, attempt to create the parent node, then try again.
! 	if ( ( $target != '/' ) && ( wp_mkdir_p( dirname( $target ) ) ) )
! 		return wp_mkdir_p( $target );
  
  	return false;
  }
--- 1365,1387 ----
  	if ( file_exists( $target ) )
  		return @is_dir( $target );
  
! 	// We need to find the permissions of the parent folder that exists and inherit that.
! 	$target_parent = dirname( $target );
! 	while ( '.' != $target_parent && ! is_dir( $target_parent ) ) {
! 		$target_parent = dirname( $target_parent );
  	}
  
! 	// Get the permission bits.
! 	if ( $target_parent && '.' != $target_parent ) {
! 		$stat = @stat( $target_parent );
! 		$dir_perms = $stat['mode'] & 0007777;
! 	} else {
! 		$dir_perms = 0777;
! 	}
! 
! 	if ( @mkdir( $target, $dir_perms, true ) ) {
! 		return true;
! 	}
  
  	return false;
  }
***************
*** 1443,1449 ****
  	}
  
  	$temp = ini_get('upload_tmp_dir');
! 	if ( is_dir( $temp ) && wp_is_writable( $temp ) )
  		return trailingslashit( rtrim( $temp, '\\' ) );
  
  	$temp = WP_CONTENT_DIR . '/';
--- 1457,1463 ----
  	}
  
  	$temp = ini_get('upload_tmp_dir');
! 	if ( @is_dir( $temp ) && wp_is_writable( $temp ) )
  		return trailingslashit( rtrim( $temp, '\\' ) );
  
  	$temp = WP_CONTENT_DIR . '/';
***************
*** 1569,1575 ****
  	}
  
  	// If multisite (and if not the main site in a post-MU network)
! 	if ( is_multisite() && ! ( is_main_site() && defined( 'MULTISITE' ) ) ) {
  
  		if ( ! get_site_option( 'ms_files_rewriting' ) ) {
  			// If ms-files rewriting is disabled (networks created post-3.5), it is fairly straightforward:
--- 1583,1589 ----
  	}
  
  	// If multisite (and if not the main site in a post-MU network)
! 	if ( is_multisite() && ! ( is_main_network() && is_main_site() && defined( 'MULTISITE' ) ) ) {
  
  		if ( ! get_site_option( 'ms_files_rewriting' ) ) {
  			// If ms-files rewriting is disabled (networks created post-3.5), it is fairly straightforward:
***************
*** 1799,1805 ****
--- 1813,1821 ----
   * @return string|null The file type, example: audio, video, document, spreadsheet, etc. Null if not found.
   */
  function wp_ext2type( $ext ) {
+ 	$ext = strtolower( $ext );
  	$ext2type = apply_filters( 'ext2type', array(
+ 		'image'       => array( 'jpg', 'jpeg', 'jpe',  'gif',  'png',  'bmp',   'tif',  'tiff', 'ico' ),
  		'audio'       => array( 'aac', 'ac3',  'aif',  'aiff', 'm3a',  'm4a',   'm4b',  'mka',  'mp1',  'mp2',  'mp3', 'ogg', 'oga', 'ram', 'wav', 'wma' ),
  		'video'       => array( 'asf', 'avi',  'divx', 'dv',   'flv',  'm4v',   'mkv',  'mov',  'mp4',  'mpeg', 'mpg', 'mpv', 'ogm', 'ogv', 'qt',  'rm', 'vob', 'wmv' ),
  		'document'    => array( 'doc', 'docx', 'docm', 'dotm', 'odt',  'pages', 'pdf',  'rtf',  'wp',   'wpd' ),
***************
*** 1808,1817 ****
  		'text'        => array( 'asc', 'csv',  'tsv',  'txt' ),
  		'archive'     => array( 'bz2', 'cab',  'dmg',  'gz',   'rar',  'sea',   'sit',  'sqx',  'tar',  'tgz',  'zip', '7z' ),
  		'code'        => array( 'css', 'htm',  'html', 'php',  'js' ),
! 	));
  	foreach ( $ext2type as $type => $exts )
  		if ( in_array( $ext, $exts ) )
  			return $type;
  }
  
  /**
--- 1824,1836 ----
  		'text'        => array( 'asc', 'csv',  'tsv',  'txt' ),
  		'archive'     => array( 'bz2', 'cab',  'dmg',  'gz',   'rar',  'sea',   'sit',  'sqx',  'tar',  'tgz',  'zip', '7z' ),
  		'code'        => array( 'css', 'htm',  'html', 'php',  'js' ),
! 	) );
! 
  	foreach ( $ext2type as $type => $exts )
  		if ( in_array( $ext, $exts ) )
  			return $type;
+ 
+ 	return null;
  }
  
  /**
***************
*** 1854,1861 ****
   *
   * @since 3.0.0
   *
!  * @param string $file Full path to the image.
!  * @param string $filename The filename of the image (may differ from $file due to $file being in a tmp directory)
   * @param array $mimes Optional. Key is the file extension with value as the mime type.
   * @return array Values for the extension, MIME, and either a corrected filename or false if original $filename is valid
   */
--- 1873,1880 ----
   *
   * @since 3.0.0
   *
!  * @param string $file Full path to the file.
!  * @param string $filename The name of the file (may differ from $file due to $file being in a tmp directory)
   * @param array $mimes Optional. Key is the file extension with value as the mime type.
   * @return array Values for the extension, MIME, and either a corrected filename or false if original $filename is valid
   */
***************
*** 3219,3226 ****
  	if ( defined('WP_SITEURL') && '' != WP_SITEURL ) {
  		$url = WP_SITEURL;
  	} else {
  		$schema = is_ssl() ? 'https://' : 'http://'; // set_url_scheme() is not defined yet
! 		$url = preg_replace( '#/(wp-admin/.*|wp-login.php)#i', '', $schema . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] );
  	}
  
  	return rtrim($url, '/');
--- 3238,3273 ----
  	if ( defined('WP_SITEURL') && '' != WP_SITEURL ) {
  		$url = WP_SITEURL;
  	} else {
+ 		$abspath_fix = str_replace( '\\', '/', ABSPATH );
+ 		$script_filename_dir = dirname( $_SERVER['SCRIPT_FILENAME'] );
+ 
+ 		// The request is for the admin
+ 		if ( strpos( $_SERVER['REQUEST_URI'], 'wp-admin' ) !== false || strpos( $_SERVER['REQUEST_URI'], 'wp-login.php' ) !== false ) {
+ 			$path = preg_replace( '#/(wp-admin/.*|wp-login.php)#i', '', $_SERVER['REQUEST_URI'] );
+ 
+ 		// The request is for a file in ABSPATH
+ 		} elseif ( $script_filename_dir . '/' == $abspath_fix ) {
+ 			// Strip off any file/query params in the path
+ 			$path = preg_replace( '#/[^/]*$#i', '', $_SERVER['PHP_SELF'] );
+ 
+ 		} else {
+ 			if ( false !== strpos( $_SERVER['SCRIPT_FILENAME'], $abspath_fix ) ) {
+ 				// Request is hitting a file inside ABSPATH
+ 				$directory = str_replace( ABSPATH, '', $script_filename_dir );
+ 				// Strip off the sub directory, and any file/query paramss
+ 				$path = preg_replace( '#/' . preg_quote( $directory, '#' ) . '/[^/]*$#i', '' , $_SERVER['REQUEST_URI'] );
+ 			} elseif ( false !== strpos( $abspath_fix, $script_filename_dir ) ) {
+ 				// Request is hitting a file above ABSPATH
+ 				$subdirectory = str_replace( $script_filename_dir, '', $abspath_fix );
+ 				// Strip off any file/query params from the path, appending the sub directory to the install
+ 				$path = preg_replace( '#/[^/]*$#i', '' , $_SERVER['REQUEST_URI'] ) . $subdirectory;
+ 			} else {
+ 				$path = $_SERVER['REQUEST_URI'];
+ 			}
+ 		}
+ 
  		$schema = is_ssl() ? 'https://' : 'http://'; // set_url_scheme() is not defined yet
! 		$url = $schema . $_SERVER['HTTP_HOST'] . $path;
  	}
  
  	return rtrim($url, '/');
***************
*** 3271,3295 ****
  }
  
  /**
!  * Is main site?
!  *
   *
   * @since 3.0.0
-  * @package WordPress
   *
!  * @param int $blog_id optional blog id to test (default current blog)
!  * @return bool True if not multisite or $blog_id is main site
   */
! function is_main_site( $blog_id = '' ) {
  	global $current_site;
  
  	if ( ! is_multisite() )
  		return true;
  
! 	if ( ! $blog_id )
! 		$blog_id = get_current_blog_id();
  
! 	return $blog_id == $current_site->blog_id;
  }
  
  /**
--- 3318,3378 ----
  }
  
  /**
!  * Whether a site is the main site of the current network.
   *
   * @since 3.0.0
   *
!  * @param int $site_id Optional. Site ID to test. Defaults to current site.
!  * @return bool True if $site_id is the main site of the network, or if not running multisite.
   */
! function is_main_site( $site_id = null ) {
! 	// This is the current network's information; 'site' is old terminology.
  	global $current_site;
  
  	if ( ! is_multisite() )
  		return true;
  
! 	if ( ! $site_id )
! 		$site_id = get_current_blog_id();
  
! 	return (int) $site_id === (int) $current_site->blog_id;
! }
! 
! /**
!  * Whether a network is the main network of the multisite install.
!  *
!  * @since 3.7.0
!  *
!  * @param int $network_id Optional. Network ID to test. Defaults to current network.
!  * @return bool True if $network_id is the main network, or if not running multisite.
!  */
! function is_main_network( $network_id = null ) {
! 	global $current_site, $wpdb;
! 
! 	if ( ! is_multisite() )
! 		return true;
! 
! 	$current_network_id = (int) $current_site->id;
! 
! 	if ( ! $network_id )
! 		$network_id = $current_network_id;
! 	$network_id = (int) $network_id;
! 
! 	if ( defined( 'PRIMARY_NETWORK_ID' ) )
! 		return $network_id === (int) PRIMARY_NETWORK_ID;
! 
! 	if ( 1 === $current_network_id )
! 		return $network_id === $current_network_id;
! 
! 	$primary_network_id = (int) wp_cache_get( 'primary_network_id', 'site-options' );
! 
! 	if ( $primary_network_id )
! 		return $network_id === $primary_network_id;
! 
! 	$primary_network_id = (int) $wpdb->get_var( "SELECT id FROM $wpdb->site ORDER BY id LIMIT 1" );
! 	wp_cache_add( 'primary_network_id', $primary_network_id, 'site-options' );
! 
! 	return $network_id === $primary_network_id;
  }
  
  /**
***************
*** 3339,3350 ****
  }
  
  /**
!  * {@internal Missing Short Description}}
   *
   * @since 2.9.0
   *
!  * @param unknown_type $a
!  * @param unknown_type $b
   * @return int
   */
  function _wp_timezone_choice_usort_callback( $a, $b ) {
--- 3422,3433 ----
  }
  
  /**
!  * Sort-helper for timezones.
   *
   * @since 2.9.0
   *
!  * @param array $a
!  * @param array $b
   * @return int
   */
  function _wp_timezone_choice_usort_callback( $a, $b ) {
***************
*** 3620,3638 ****
  }
  
  /**
-  * Used internally to tidy up the search terms.
-  *
-  * @access private
-  * @since 2.9.0
-  *
-  * @param string $t
-  * @return string
-  */
- function _search_terms_tidy($t) {
- 	return trim($t, "\"'\n\r ");
- }
- 
- /**
   * Returns true.
   *
   * Useful for returning true to filters easily.
--- 3703,3708 ----
***************
*** 3697,3702 ****
--- 3767,3785 ----
  }
  
  /**
+  * Returns an empty string.
+  *
+  * Useful for returning an empty string to filters easily.
+  *
+  * @since 3.7.0
+  * @see __return_null()
+  * @return string Empty string
+  */
+ function __return_empty_string() {
+ 	return '';
+ }
+ 
+ /**
   * Send a HTTP header to disable content type sniffing in browsers which support it.
   *
   * @link http://blogs.msdn.com/ie/archive/2008/07/02/ie8-security-part-v-comprehensive-protection.aspx
***************
*** 4070,4072 ****
--- 4153,4206 ----
  
  	return $charset;
  }
+ 
+ /**
+  * Sets the mbstring internal encoding to a binary safe encoding whne func_overload is enabled.
+  *
+  * When mbstring.func_overload is in use for multi-byte encodings, the results from strlen() and
+  * similar functions respect the utf8 characters, causing binary data to return incorrect lengths.
+  *
+  * This function overrides the mbstring encoding to a binary-safe encoding, and resets it to the
+  * users expected encoding afterwards through the `reset_mbstring_encoding` function.
+  *
+  * It is safe to recursively call this function, however each `mbstring_binary_safe_encoding()`
+  * call must be followed up with an equal number of `reset_mbstring_encoding()` calls.
+  *
+  * @see reset_mbstring_encoding()
+  *
+  * @since 3.7.0
+  *
+  * @param bool $reset Whether to reset the encoding back to a previously-set encoding.
+  */
+ function mbstring_binary_safe_encoding( $reset = false ) {
+ 	static $encodings = array();
+ 	static $overloaded = null;
+ 
+ 	if ( is_null( $overloaded ) )
+ 		$overloaded = function_exists( 'mb_internal_encoding' ) && ( ini_get( 'mbstring.func_overload' ) & 2 );
+ 
+ 	if ( false === $overloaded )
+ 		return;
+ 
+ 	if ( ! $reset ) {
+ 		$encoding = mb_internal_encoding();
+ 		array_push( $encodings, $encoding );
+ 		mb_internal_encoding( 'ISO-8859-1' );
+ 	}
+ 
+ 	if ( $reset && $encodings ) {
+ 		$encoding = array_pop( $encodings );
+ 		mb_internal_encoding( $encoding );
+ 	}
+ }
+ 
+ /**
+  * Resets the mbstring internal encoding to a users previously set encoding.
+  *
+  * @see mbstring_binary_safe_encoding()
+  *
+  * @since 3.7.0
+  */
+ function reset_mbstring_encoding() {
+ 	mbstring_binary_safe_encoding( true );
+ }
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/functions.wp-scripts.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/functions.wp-scripts.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/functions.wp-scripts.php	2013-03-11 04:39:55.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/functions.wp-scripts.php	2013-09-23 21:58:09.000000000 -0500
***************
*** 1,22 ****
  <?php
  /**
!  * BackPress script procedural API.
   *
!  * @package BackPress
!  * @since r16
   */
  
  /**
!  * Prints script tags in document head.
   *
!  * Called by admin-header.php and by wp_head hook. Since it is called by wp_head
!  * on every page load, the function does not instantiate the WP_Scripts object
!  * unless script names are explicitly passed. Does make use of already
!  * instantiated $wp_scripts if present. Use provided wp_print_scripts hook to
!  * register/enqueue new scripts.
   *
!  * @since r16
!  * @see WP_Dependencies::print_scripts()
   */
  function wp_print_scripts( $handles = false ) {
  	do_action( 'wp_print_scripts' );
--- 1,28 ----
  <?php
  /**
!  * BackPress Scripts Procedural API
   *
!  * @since 2.6.0
!  *
!  * @package WordPress
!  * @subpackage BackPress
   */
  
  /**
!  * Print scripts in document head that are in the $handles queue.
!  *
!  * Called by admin-header.php and wp_head hook. Since it is called by wp_head on every page load,
!  * the function does not instantiate the WP_Scripts object unless script names are explicitly passed.
!  * Makes use of already-instantiated $wp_scripts global if present. Use provided wp_print_scripts
!  * hook to register/enqueue new scripts.
   *
!  * @see WP_Scripts::do_items()
!  * @global WP_Scripts $wp_scripts The WP_Scripts object for printing scripts.
   *
!  * @since 2.6.0
!  *
!  * @param array|bool $handles Optional. Scripts to be printed. Default 'false'.
!  * @return array On success, a processed array of WP_Dependencies items; otherwise, an empty array.
   */
  function wp_print_scripts( $handles = false ) {
  	do_action( 'wp_print_scripts' );
***************
*** 39,53 ****
  }
  
  /**
!  * Register new Javascript file.
   *
!  * @since r16
!  * @param string $handle Script name
!  * @param string $src Script url
!  * @param array $deps (optional) Array of script names on which this script depends
!  * @param string|bool $ver (optional) Script version (used for cache busting), set to null to disable
!  * @param bool $in_footer (optional) Whether to enqueue the script before </head> or before </body>
!  * @return null
   */
  function wp_register_script( $handle, $src, $deps = array(), $ver = false, $in_footer = false ) {
  	global $wp_scripts;
--- 45,69 ----
  }
  
  /**
!  * Register a new script.
!  *
!  * Registers a script to be linked later using the wp_enqueue_script() function.
   *
!  * @see WP_Dependencies::add(), WP_Dependencies::add_data()
!  * @global WP_Scripts $wp_scripts The WP_Scripts object for printing scripts.
!  *
!  * @since 2.6.0
!  *
!  * @param string      $handle    Name of the script. Should be unique.
!  * @param string      $src       Path to the script from the WordPress root directory. Example: '/js/myscript.js'.
!  * @param array       $deps      Optional. An array of registered script handles this script depends on. Set to false if there
!  *                               are no dependencies. Default empty array.
!  * @param string|bool $ver       Optional. String specifying script version number, if it has one, which is concatenated
!  *                               to end of path as a query string. If no version is specified or set to false, a version
!  *                               number is automatically added equal to current installed WordPress version.
!  *                               If set to null, no version is added. Default 'false'. Accepts 'false', 'null', or 'string'.
!  * @param bool        $in_footer Optional. Whether to enqueue the script before </head> or before </body>.
!  *                               Default 'false'. Accepts 'false' or 'true'.
   */
  function wp_register_script( $handle, $src, $deps = array(), $ver = false, $in_footer = false ) {
  	global $wp_scripts;
***************
*** 64,87 ****
  }
  
  /**
!  * Wrapper for $wp_scripts->localize().
   *
-  * Used to localize a script.
   * Works only if the script has already been added.
!  * Accepts an associative array $l10n and creates JS object:
   * "$object_name" = {
!  *   key: value,
!  *   key: value,
!  *   ...
   * }
!  * See http://core.trac.wordpress.org/ticket/11520 for more information.
!  *
!  * @since r16
   *
!  * @param string $handle The script handle that was registered or used in script-loader
!  * @param string $object_name Name for the created JS object. This is passed directly so it should be qualified JS variable /[a-zA-Z0-9_]+/
!  * @param array $l10n Associative PHP array containing the translated strings. HTML entities will be converted and the array will be JSON encoded.
!  * @return bool Whether the localization was added successfully.
   */
  function wp_localize_script( $handle, $object_name, $l10n ) {
  	global $wp_scripts;
--- 80,109 ----
  }
  
  /**
!  * Localize a script.
   *
   * Works only if the script has already been added.
!  *
!  * Accepts an associative array $l10n and creates a JavaScript object:
!  * <code>
   * "$object_name" = {
!  *       key: value,
!  *       key: value,
!  *       ...
   * }
!  * </code>
   *
!  * @see WP_Dependencies::localize()
!  * @link http://core.trac.wordpress.org/ticket/11520
!  * @global WP_Scripts $wp_scripts The WP_Scripts object for printing scripts.
!  *
!  * @since 2.6.0
!  *
!  * @param string $handle      Script handle the data will be attached to.
!  * @param string $object_name Name for the JavaScript object. Passed directly, so it should be qualified JS variable.
!  *                            Example: '/[a-zA-Z0-9_]+/'.
!  * @param array $l10n         The data itself. The data can be either a single or multi-dimensional array.
!  * @return bool True if the script was successfully localized, false otherwise.
   */
  function wp_localize_script( $handle, $object_name, $l10n ) {
  	global $wp_scripts;
***************
*** 99,106 ****
  /**
   * Remove a registered script.
   *
!  * @since r16
!  * @see WP_Scripts::remove() For parameter information.
   */
  function wp_deregister_script( $handle ) {
  	global $wp_scripts;
--- 121,135 ----
  /**
   * Remove a registered script.
   *
!  * Note: there are intentional safeguards in place to prevent critical admin scripts,
!  * such as jQuery core, from being unregistered.
!  *
!  * @see WP_Dependencies::remove()
!  * @global WP_Scripts $wp_scripts The WP_Scripts object for printing scripts.
!  *
!  * @since 2.6.0
!  *
!  * @param string $handle Name of the script to be removed.
   */
  function wp_deregister_script( $handle ) {
  	global $wp_scripts;
***************
*** 111,126 ****
  		$wp_scripts = new WP_Scripts();
  	}
  
! 	// Do not allow accidental or negligent deregistering of critical scripts in the admin. Show minimal remorse if the correct hook is used.
! 	if ( is_admin() && 'admin_enqueue_scripts' !== current_filter() ) {
  		$no = array(
  			'jquery', 'jquery-core', 'jquery-migrate', 'jquery-ui-core', 'jquery-ui-accordion',
  			'jquery-ui-autocomplete', 'jquery-ui-button', 'jquery-ui-datepicker', 'jquery-ui-dialog',
  			'jquery-ui-draggable', 'jquery-ui-droppable', 'jquery-ui-menu', 'jquery-ui-mouse',
  			'jquery-ui-position', 'jquery-ui-progressbar', 'jquery-ui-resizable', 'jquery-ui-selectable',
  			'jquery-ui-slider', 'jquery-ui-sortable', 'jquery-ui-spinner', 'jquery-ui-tabs',
! 			'jquery-ui-tooltip', 'jquery-ui-widget',
! 			'underscore', 'backbone',
  		);
  
  		if ( in_array( $handle, $no ) ) {
--- 140,160 ----
  		$wp_scripts = new WP_Scripts();
  	}
  
! 	/**
! 	 * Do not allow accidental or negligent de-registering of critical scripts in the admin.
! 	 * Show minimal remorse if the correct hook is used.
! 	 */
! 	$current_filter = current_filter();
! 	if ( ( is_admin() && 'admin_enqueue_scripts' !== $current_filter ) ||
! 		( 'wp-login.php' === $GLOBALS['pagenow'] && 'login_enqueue_scripts' !== $current_filter )
! 	) {
  		$no = array(
  			'jquery', 'jquery-core', 'jquery-migrate', 'jquery-ui-core', 'jquery-ui-accordion',
  			'jquery-ui-autocomplete', 'jquery-ui-button', 'jquery-ui-datepicker', 'jquery-ui-dialog',
  			'jquery-ui-draggable', 'jquery-ui-droppable', 'jquery-ui-menu', 'jquery-ui-mouse',
  			'jquery-ui-position', 'jquery-ui-progressbar', 'jquery-ui-resizable', 'jquery-ui-selectable',
  			'jquery-ui-slider', 'jquery-ui-sortable', 'jquery-ui-spinner', 'jquery-ui-tabs',
! 			'jquery-ui-tooltip', 'jquery-ui-widget', 'underscore', 'backbone',
  		);
  
  		if ( in_array( $handle, $no ) ) {
***************
*** 135,146 ****
  }
  
  /**
!  * Enqueues script.
   *
!  * Registers the script if src provided (does NOT overwrite) and enqueues.
   *
!  * @since r16
!  * @see wp_register_script() For parameter information.
   */
  function wp_enqueue_script( $handle, $src = false, $deps = array(), $ver = false, $in_footer = false ) {
  	global $wp_scripts;
--- 169,191 ----
  }
  
  /**
!  * Enqueue a script.
!  *
!  * Registers the script if $src provided (does NOT overwrite), and enqueues it.
   *
!  * @see WP_Dependencies::add(), WP_Dependencies::add_data(), WP_Dependencies::enqueue()
!  * @global WP_Scripts $wp_scripts The WP_Scripts object for printing scripts.
   *
!  * @since 2.6.0
! 
!  * @param string      $handle    Name of the script.
!  * @param string|bool $src       Path to the script from the root directory of WordPress. Example: '/js/myscript.js'.
!  * @param array       $deps      An array of registered handles this script depends on. Default empty array.
!  * @param string|bool $ver       Optional. String specifying the script version number, if it has one. This parameter
!  *                               is used to ensure that the correct version is sent to the client regardless of caching,
!  *                               and so should be included if a version number is available and makes sense for the script.
!  * @param bool        $in_footer Optional. Whether to enqueue the script before </head> or before </body>.
!  *                               Default 'false'. Accepts 'false' or 'true'.
   */
  function wp_enqueue_script( $handle, $src = false, $deps = array(), $ver = false, $in_footer = false ) {
  	global $wp_scripts;
***************
*** 161,170 ****
  }
  
  /**
!  * Remove an enqueued script.
   *
!  * @since WP 3.1
!  * @see WP_Scripts::dequeue() For parameter information.
   */
  function wp_dequeue_script( $handle ) {
  	global $wp_scripts;
--- 206,219 ----
  }
  
  /**
!  * Remove a previously enqueued script.
!  *
!  * @see WP_Dependencies::dequeue()
!  * @global WP_Scripts $wp_scripts The WP_Scripts object for printing scripts.
!  *
!  * @since 3.1.0
   *
!  * @param string $handle Name of the script to be removed.
   */
  function wp_dequeue_script( $handle ) {
  	global $wp_scripts;
***************
*** 179,196 ****
  }
  
  /**
!  * Check whether script has been added to WordPress Scripts.
   *
!  * By default, checks if the script has been enqueued. You can also
!  * pass 'registered' to $list, to see if the script is registered,
!  * and you can check processing statuses with 'to_do' and 'done'.
   *
!  * @since WP unknown; BP unknown
   *
   * @param string $handle Name of the script.
!  * @param string $list Optional. Defaults to 'enqueued'. Values are
!  * 	'registered', 'enqueued' (or 'queue'), 'to_do', and 'done'.
!  * @return bool Whether script is in the list.
   */
  function wp_script_is( $handle, $list = 'enqueued' ) {
  	global $wp_scripts;
--- 228,244 ----
  }
  
  /**
!  * Check whether a script has been added to the queue.
   *
!  * @global WP_Scripts $wp_scripts The WP_Scripts object for printing scripts.
   *
!  * @since 2.8.0
!  * @since 3.5.0 'enqueued' added as an alias of the 'queue' list.
   *
   * @param string $handle Name of the script.
!  * @param string $list   Optional. Status of the script to check. Default 'enqueued'.
!  *                       Accepts 'enqueued', 'registered', 'queue', 'to_do', and 'done'.
!  * @return bool Whether the script script is queued.
   */
  function wp_script_is( $handle, $list = 'enqueued' ) {
  	global $wp_scripts;
